package com.huigou.topsun.product.domain;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import lombok.Data;
import org.hibernate.annotations.GenericGenerator;

/**
 * 尺码组主表
 * @TableName size_group
 */
@Table(name="size_group")
@Data
public class SizeGroup implements Serializable {
    /**
     * 尺码组id
     */
    @Id
    @GeneratedValue(generator = "system-uuid")
    @GenericGenerator(name = "system-uuid", strategy = "guid")
    @Column(name = "size_group_id")
    private String sizeGroupId;

    /**
     * 尺码组名称
     */
    @Column(name = "size_group_name")
    private String sizeGroupName;

    /**
     * 尺码组编码
     */
    @Column(name = "size_group_code")
    private String sizeGroupCode;

    /**
     * 尺码组类型
     */
    @Column(name = "size_group_type")
    private String sizeGroupType;

    private static final long serialVersionUID = 1L;
}